/*
MySQL Data Transfer
Source Host: localhost
Source Database: checkup
Target Host: localhost
Target Database: checkup
Date: 20/11/2007 21:06:18
*/

SET FOREIGN_KEY_CHECKS=0;
-- ----------------------------
-- Table structure for tblcode
-- ----------------------------
CREATE TABLE `tblcode` (
  `Code` tinyint(4) NOT NULL default '0',
  `Detail` varchar(255) NOT NULL default '',
  `Label` varchar(50) default NULL,
  PRIMARY KEY  (`Code`)
) ENGINE=MyISAM DEFAULT CHARSET=tis620;

-- ----------------------------
-- Table structure for tbldiag
-- ----------------------------
CREATE TABLE `tbldiag` (
  `IDYear` bigint(20) NOT NULL default '0',
  `ID` int(11) NOT NULL default '0',
  `Year` mediumint(4) NOT NULL default '0',
  `Office` varchar(50) NOT NULL default '',
  `CodeDetail` varchar(255) default NULL
) ENGINE=MyISAM DEFAULT CHARSET=tis620;

-- ----------------------------
-- Table structure for tbldoctor
-- ----------------------------
CREATE TABLE `tbldoctor` (
  `UserID` varchar(5) NOT NULL default '',
  `Name` varchar(50) default NULL,
  `Password` varchar(32) default NULL,
  `Active` tinyint(1) default '1',
  `Doctor` tinyint(1) default '0',
  `Whoupd` varchar(5) default NULL,
  PRIMARY KEY  (`UserID`)
) ENGINE=MyISAM DEFAULT CHARSET=tis620;

-- ----------------------------
-- Table structure for tblfollowup
-- ----------------------------
CREATE TABLE `tblfollowup` (
  `NoID` int(11) NOT NULL auto_increment,
  `No` tinyint(4) NOT NULL default '0',
  `IDYear` bigint(20) NOT NULL default '0',
  `ID` int(11) default NULL,
  `Year` mediumint(4) default NULL,
  `Date` date default NULL,
  `FBS` varchar(255) default NULL,
  `BUN` varchar(255) default NULL,
  `Creatinine` varchar(255) default NULL,
  `AlkP` varchar(255) default NULL,
  `SGOT` varchar(255) default NULL,
  `SGPT` varchar(255) default NULL,
  `CHOL` varchar(255) default NULL,
  `TG` varchar(255) default NULL,
  `HDL` varchar(255) default NULL,
  `LDL` varchar(255) default NULL,
  `Uric` varchar(255) default NULL,
  `Other` varchar(255) default NULL,
  `Conclude` varchar(255) default '0',
  `Whoupd` varchar(50) default NULL,
  PRIMARY KEY  (`NoID`)
) ENGINE=MyISAM DEFAULT CHARSET=tis620;

-- ----------------------------
-- Table structure for tblnormal
-- ----------------------------
CREATE TABLE `tblnormal` (
  `Sex` char(1) NOT NULL default '',
  `LBheme` varchar(15) default NULL,
  `UBheme` varchar(15) default NULL,
  `Bheme` varchar(15) default NULL,
  `LBhct` varchar(15) default NULL,
  `UBhct` varchar(15) default NULL,
  `Bhct` varchar(15) default NULL,
  `LBwbc` varchar(15) default NULL,
  `UBwbc` varchar(15) default NULL,
  `Bwbc` varchar(20) default NULL,
  `LBrbc` varchar(15) default NULL,
  `UBrbc` varchar(15) default NULL,
  `Brbc` varchar(15) default NULL,
  `LMmcv` varchar(15) default NULL,
  `UMmcv` varchar(15) default NULL,
  `Mmcv` varchar(15) default NULL,
  `LBmch` varchar(15) default NULL,
  `UBmch` varchar(15) default NULL,
  `Bmch` varchar(15) default NULL,
  `LBmchc` varchar(15) default NULL,
  `UBmchc` varchar(15) default NULL,
  `Bmchc` varchar(15) default NULL,
  `Brdw` varchar(15) default NULL,
  `NBrdw` varchar(15) default NULL,
  `NBmpv` varchar(15) default NULL,
  `Bmpv` varchar(15) default NULL,
  `LBn` varchar(15) default NULL,
  `UBn` varchar(15) default NULL,
  `Bn` varchar(15) default NULL,
  `LBl` varchar(15) default NULL,
  `UBl` varchar(15) default NULL,
  `Bl` varchar(15) default NULL,
  `LBe` varchar(15) default NULL,
  `UBe` varchar(15) default NULL,
  `Be` varchar(15) default NULL,
  `LBm` varchar(15) default NULL,
  `UBm` varchar(15) default NULL,
  `Bm` varchar(15) default NULL,
  `NBb` varchar(15) default NULL,
  `Bb` varchar(15) default NULL,
  `Bal` varchar(15) default NULL,
  `LBplt` varchar(15) default NULL,
  `UBplt` varchar(15) default NULL,
  `Bplt` varchar(25) default NULL,
  `LCfbs` varchar(15) default NULL,
  `UCfbs` varchar(15) default NULL,
  `Cfbs` varchar(15) default NULL,
  `LCbun` varchar(15) default NULL,
  `UCbun` varchar(15) default NULL,
  `Cbun` varchar(15) default NULL,
  `LCcr` varchar(15) default NULL,
  `UCcr` varchar(15) default NULL,
  `Ccr` varchar(15) default NULL,
  `LCuric` varchar(15) default NULL,
  `UCuric` varchar(15) default NULL,
  `Curic` varchar(15) default NULL,
  `LCchol` varchar(15) default NULL,
  `UCchol` varchar(15) default NULL,
  `Cchol` varchar(15) default NULL,
  `LCtg` varchar(15) default NULL,
  `UCtg` varchar(15) default NULL,
  `Ctg` varchar(15) default NULL,
  `LCHDL` varchar(15) default NULL,
  `UCHDL` varchar(15) default NULL,
  `CHDL` varchar(15) default NULL,
  `NCLDL` varchar(15) default NULL,
  `CLDL` varchar(15) default NULL,
  `LCalk` varchar(15) default NULL,
  `UCalk` varchar(15) default NULL,
  `Calk` varchar(15) default NULL,
  `Csgot` varchar(15) default NULL,
  `Nsgot` varchar(15) default NULL,
  `Nsgpt` varchar(15) default NULL,
  `Csgpt` varchar(15) default NULL,
  `Chbag` varchar(15) default NULL,
  `Chbab` varchar(15) default NULL,
  `Ct3` varchar(15) default NULL,
  `Ct4` varchar(16) default NULL,
  `Ctsh` varchar(18) default NULL,
  `LCt3` varchar(15) default NULL,
  `UCt3` varchar(15) default NULL,
  `LCt4` varchar(15) default NULL,
  `UCt4` varchar(15) default NULL,
  `LCtsh` varchar(15) default NULL,
  `UCtsh` varchar(15) default NULL,
  `Ualb` varchar(15) default NULL,
  `Uglc` varchar(15) default NULL,
  `LUph` varchar(15) default NULL,
  `UUph` varchar(15) default NULL,
  `Uph` varchar(15) default NULL,
  `LUsp` varchar(15) default NULL,
  `UUsp` varchar(15) default NULL,
  `Usp` varchar(15) default NULL,
  `Uwbc` varchar(15) default NULL,
  `Urbc` varchar(15) default NULL,
  `Ucast` varchar(15) default NULL,
  `Sparas` varchar(15) default NULL,
  `Srbc` varchar(15) default NULL,
  PRIMARY KEY  (`Sex`)
) ENGINE=MyISAM DEFAULT CHARSET=tis620;

-- ----------------------------
-- Table structure for tblpersonel
-- ----------------------------
CREATE TABLE `tblpersonel` (
  `ID` int(11) NOT NULL auto_increment,
  `Now` varchar(4) default NULL,
  `Pname` varchar(15) default NULL,
  `Sex` char(1) default NULL,
  `Fname` varchar(25) default NULL,
  `Lname` varchar(30) default NULL,
  `Birthday` tinyint(2) default NULL,
  `Birthmonth` tinyint(2) default NULL,
  `Birthyear` mediumint(4) default NULL,
  `PID` varchar(13) default NULL,
  `Office` varchar(255) default NULL,
  `Ono` varchar(10) default NULL,
  `Omoo` char(2) default NULL,
  `Oban` varchar(50) default NULL,
  `Osoi` varchar(50) default NULL,
  `Oroad` varchar(50) default NULL,
  `Otambon` varchar(50) default NULL,
  `Oampur` varchar(50) default NULL,
  `Oprovince` varchar(50) default NULL,
  `Ozipcode` varchar(5) default NULL,
  `Ophone` varchar(50) default NULL,
  `Ofax` varchar(50) default NULL,
  `No` varchar(10) default NULL,
  `Moo` char(2) default NULL,
  `Ban` varchar(50) default NULL,
  `Soi` varchar(50) default NULL,
  `Road` varchar(50) default NULL,
  `Tambon` varchar(50) default NULL,
  `Ampur` varchar(50) default NULL,
  `Province` varchar(50) default NULL,
  `Zipcode` varchar(5) default NULL,
  `Phone` varchar(50) default NULL,
  `Moblie` varchar(50) default NULL,
  `Hallergy` varchar(255) default NULL,
  `Hillness` varchar(255) default NULL,
  `Hdrug` varchar(255) default NULL,
  `Hparent` varchar(50) default NULL,
  `Hrelative` varchar(50) default NULL,
  `Hself` varchar(50) default NULL,
  `Hcure` varchar(50) default NULL,
  `Bsmoke` varchar(255) default NULL,
  `Balcohol` varchar(255) default NULL,
  `Bactivity` varchar(255) default NULL,
  `Bfood` varchar(50) default NULL,
  `Bdriver` varchar(100) default NULL,
  `Bcondom` varchar(50) default NULL,
  `Whoupd` varchar(5) default NULL,
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=tis620;

-- ----------------------------
-- Table structure for tblprice
-- ----------------------------
CREATE TABLE `tblprice` (
  `IDYear` bigint(20) NOT NULL default '0',
  `ID` int(11) default NULL,
  `Year` mediumint(4) default NULL,
  `Chest` varchar(50) default NULL,
  `EKG` varchar(50) default NULL,
  `PAP` varchar(50) default NULL,
  `Linner` varchar(50) default NULL,
  `LHeme` varchar(50) default NULL,
  `LpH` varchar(50) default NULL,
  `LOther` varchar(50) default NULL,
  `LFBS` varchar(50) default NULL,
  `LBUN` varchar(50) default NULL,
  `LCr` varchar(50) default NULL,
  `LUric` varchar(50) default NULL,
  `LCHOL` varchar(50) default NULL,
  `LTG` varchar(50) default NULL,
  `LALKP` varchar(50) default NULL,
  `LSGOT` varchar(50) default NULL,
  `LSGPT` varchar(50) default NULL,
  `LGROUP` varchar(50) default NULL,
  `LDF` varchar(50) default NULL,
  PRIMARY KEY  (`IDYear`)
) ENGINE=MyISAM DEFAULT CHARSET=tis620;

-- ----------------------------
-- Table structure for tblrecord
-- ----------------------------
CREATE TABLE `tblrecord` (
  `IDYear` bigint(20) NOT NULL default '0',
  `ID` int(11) default NULL,
  `HN` varchar(9) default NULL,
  `Year` mediumint(4) NOT NULL default '0',
  `Date` date default NULL,
  `Weight` varchar(5) default NULL,
  `Height` varchar(5) default NULL,
  `Rate` varchar(5) default NULL,
  `Psys` int(4) default NULL,
  `Pdias` int(4) default NULL,
  `HEENT` varchar(255) default NULL,
  `CVS` varchar(255) default NULL,
  `Other` varchar(255) default NULL,
  `Pale` varchar(50) default NULL,
  `Waist` varchar(50) default NULL,
  `Coccyx` varchar(50) default NULL,
  `Chest` varchar(255) default NULL,
  `EKG` varchar(255) default NULL,
  `PAP` varchar(255) default NULL,
  `EEarleft` varchar(255) default NULL,
  `EEarleft1` varchar(9) default NULL,
  `EEarleft2` varchar(9) default NULL,
  `EEarleft3` varchar(9) default NULL,
  `EEarleft4` varchar(9) default NULL,
  `EEarleft5` varchar(9) default NULL,
  `EEarleft6` varchar(9) default NULL,
  `EEarright` varchar(255) default NULL,
  `EEarright1` varchar(9) default NULL,
  `EEarright2` varchar(9) default NULL,
  `EEarright3` varchar(9) default NULL,
  `EEarright4` varchar(9) default NULL,
  `EEarright5` varchar(9) default NULL,
  `EEarright6` varchar(9) default NULL,
  `EEyeleftFP` varchar(50) default NULL,
  `EEyerightFP` varchar(50) default NULL,
  `EEyeleftNP` varchar(50) default NULL,
  `EEyerightNP` varchar(50) default NULL,
  `EEyeleftPhoria` varchar(50) default NULL,
  `EEyerightPhoria` varchar(50) default NULL,
  `EEyeleftPeripheral` varchar(50) default NULL,
  `EEyerightPeripheral` varchar(50) default NULL,
  `EEyeDepth` varchar(50) default NULL,
  `EEyeColour` varchar(50) default NULL,
  `EEyeleft` varchar(255) default NULL,
  `EEyeright` varchar(255) default NULL,
  `ELFVCM` varchar(9) default NULL,
  `ELFEVM` varchar(9) default NULL,
  `ELFEVFECM` varchar(9) default NULL,
  `ELFVCP` varchar(9) default NULL,
  `ELFEVP` varchar(9) default NULL,
  `ELFEVFECP` varchar(9) default NULL,
  `ELFVCRP` varchar(9) default NULL,
  `ELFEVRP` varchar(9) default NULL,
  `ELFEVFECRP` varchar(9) default NULL,
  `ELung` varchar(255) default NULL,
  `LHeme` varchar(9) default NULL,
  `LHct` varchar(9) default NULL,
  `LRBC` varchar(9) default NULL,
  `LMCV` varchar(9) default NULL,
  `LMCH` varchar(9) default NULL,
  `LMCHC` varchar(9) default NULL,
  `LRDW` varchar(9) default NULL,
  `LMPV` varchar(9) default NULL,
  `LWBC` varchar(9) default NULL,
  `LN` varchar(9) default NULL,
  `LL` varchar(9) default NULL,
  `LE` varchar(9) default NULL,
  `LM` varchar(9) default NULL,
  `LB` varchar(9) default NULL,
  `LAL` varchar(9) default NULL,
  `LPlt` varchar(9) default NULL,
  `LAlbumin` varchar(9) default NULL,
  `LGlucose` varchar(9) default NULL,
  `LpH` varchar(9) default NULL,
  `LSpgr` varchar(9) default NULL,
  `LUWBC` varchar(9) default NULL,
  `LURBC` varchar(9) default NULL,
  `LKtn` varchar(9) default NULL,
  `LEtc` varchar(9) default NULL,
  `LLkc` varchar(9) default NULL,
  `LParasite` varchar(9) default NULL,
  `LSRBC` varchar(9) default NULL,
  `LOther` varchar(255) default NULL,
  `LFBS` varchar(9) default NULL,
  `LBUN` varchar(9) default NULL,
  `LCr` varchar(9) default NULL,
  `LUric` varchar(9) default NULL,
  `LCHOL` varchar(9) default NULL,
  `LTG` varchar(9) default NULL,
  `LHDL` varchar(9) default NULL,
  `LLDL` varchar(9) default NULL,
  `LALKP` varchar(9) default NULL,
  `LSGOT` varchar(9) default NULL,
  `LSGPT` varchar(9) default NULL,
  `LHBAG` varchar(9) default NULL,
  `LHBAB` varchar(9) default NULL,
  `LGROUP` varchar(9) default NULL,
  `LT3` varchar(9) default NULL,
  `LT4` varchar(9) default NULL,
  `LTSH` varchar(9) default NULL,
  `LOther2` varchar(255) default NULL,
  `LAnother1` varchar(255) default NULL,
  `RAnother1` varchar(255) default NULL,
  `LAnother2` varchar(255) default NULL,
  `RAnother2` varchar(255) default NULL,
  `LAnother3` varchar(255) default NULL,
  `RAnother3` varchar(255) default NULL,
  `LAnother4` varchar(255) default NULL,
  `RAnother4` varchar(255) default NULL,
  `LAnother5` varchar(255) default NULL,
  `RAnother5` varchar(255) default NULL,
  `Whoupd` varchar(5) default '0',
  `Timeupd` datetime default '0000-00-00 00:00:00',
  `Final` char(1) NOT NULL default '0',
  PRIMARY KEY  (`IDYear`)
) ENGINE=MyISAM DEFAULT CHARSET=tis620;

-- ----------------------------
-- Table structure for tblsummary
-- ----------------------------
CREATE TABLE `tblsummary` (
  `IDYear` bigint(20) NOT NULL default '0',
  `ID` int(11) default NULL,
  `Year` mediumint(4) default NULL,
  `Code1` varchar(255) default NULL,
  `Code2` varchar(255) default NULL,
  `Code3` varchar(255) default NULL,
  `Code4` varchar(255) default NULL,
  `Code5` varchar(255) default NULL,
  `Code6` varchar(255) default NULL,
  `Code7` varchar(255) default NULL,
  `Code8` varchar(255) default NULL,
  `Code9` varchar(255) default NULL,
  `Code10` varchar(255) default NULL,
  `Conclusion` varchar(255) default NULL,
  `Recommend` varchar(255) default NULL,
  `Remark` varchar(50) default NULL,
  `Doctor` varchar(50) default '0',
  `Whoupd` varchar(50) default NULL,
  PRIMARY KEY  (`IDYear`)
) ENGINE=MyISAM DEFAULT CHARSET=tis620;

-- ----------------------------
-- Records 
-- ----------------------------
INSERT INTO `tblcode` VALUES ('0', 'ผลการตรวจสุขภาพไม่พบความผิดปกติ ควรออกกำลังกายอย่างสม่ำเสมอ และตรวจสุขภาพปีละ 1 ครั้ง', null);
INSERT INTO `tblcode` VALUES ('1', 'น้ำหนักต่ำกว่าเกณฑ์ ควรรับประทานอาหารที่มีประโยชน์ พักผ่อนให้เพียงพอ และออกกำลังกายอย่างเหมาะสม', null);
INSERT INTO `tblcode` VALUES ('2', 'น้ำหนักเกินเกณฑ์ มีความเสี่ยงต่อการเกิดโรคหัวใจและหลอดเลือด ควรหลีกเลี่ยงอาหารประเภทไขมัน น้ำตาล \r\r\nและแป้ง รวมทั้งออกกำลังกายให้เหมาะสม', null);
INSERT INTO `tblcode` VALUES ('3', 'โรคอ้วนระดับ 1 มีความเสี่ยงต่อการเกิดปัญหาทางสุขภาพ เช่น โรคหัวใจและหลอดเลือด ความดันโลหิตสูง เบา\r\r\nหวาน เป็นต้น \nควรลดน้ำหนัก และออกกำลังกายอย่างเหมาะสม', null);
INSERT INTO `tblcode` VALUES ('4', 'โรคอ้วนระดับ 2 มีความเสี่ยงต่อการเกิดโรคหัวใจและหลอดเลือดสูง \nควรลดน้ำหนัก และออกกำลังกายอย่าง\r\r\nเหมาะสม', null);
INSERT INTO `tblcode` VALUES ('5', 'โรคอ้วนมาก มีโอกาสเกิดโรคหัวใจและหลอดเลือดสูงมาก \nควรลดน้ำหนัก และออกกำลังกายอย่างเหมาะสม', null);
INSERT INTO `tblcode` VALUES ('6', 'ความดันโลหิตต่ำ ควรบำรุงร่างกาย พักผ่อนให้เพียงพอ และออกกำลังกายอย่างเหมาะสม', null);
INSERT INTO `tblcode` VALUES ('7', 'ความดันโลหิตสูงเล็กน้อย ควรพักผ่อนให้เพียงพอ และวัดความดันโลหิตซ้ำ หลีกเลี่ยงอาหารรสเค็ม สุรา บุหรี่', null);
INSERT INTO `tblcode` VALUES ('8', 'ความดันโลหิตสูงปานกลาง ควรปรึกษาแพทย์ ควบคุมอาหารประเภทไขมันสูง อาหารรสเค็ม เครื่องดื่มแอลกอฮอล์ \r\r\nพักผ่อนให้เพียงพอ และออกกำลังกายอย่างเหมาะสม', null);
INSERT INTO `tblcode` VALUES ('9', 'ความดันโลหิตสูงมาก ควรพบแพทย์เพื่อรับการรักษาอย่างต่อเนื่อง ควบคุมอาหารประเภทไขมันสูง อาหารรสเค็ม \r\r\nเครื่องดื่มแอลกอฮอล์ พักผ่อนให้เพียงพอ และออกกำลังกายอย่างเหมาะสม', null);
INSERT INTO `tblcode` VALUES ('10', 'ตาเป็นต้อลม ควรหลีกเลี่ยงฝุ่น ลม และแสงแดด แนะนำให้สวมแว่นตาเพื่อป้องกันแสงแดดและสิ่งระคายเคืองตา', null);
INSERT INTO `tblcode` VALUES ('11', 'ตาเป็นต้อเนื้อ ควรหลีกเลี่ยงฝุ่น ลม และแสงแดด แนะนำให้สวมแว่นตาเพื่อป้องกันแสงแดดและสิ่งระคายเคืองตา \r\r\nหากมีการลุกลามมากขึ้น ทำให้มีปัญหาการมองเห็น ควรพบจักษุแพทย์', null);
INSERT INTO `tblcode` VALUES ('12', 'ผลเอ็กซเรย์ทรวงอก พบความผิดปกติ ควรพบแพทย์', null);
INSERT INTO `tblcode` VALUES ('13', 'ผลการตรวจคลื่นไฟฟ้าหัวใจ พบความผิดปกติ หากมีอาการหน้ามืด เจ็บหน้าอก ใจสั่น ควรเข้ารับการตรวจรักษาที่\r\r\nโรงพยาบาล', null);
INSERT INTO `tblcode` VALUES ('15', 'ผลการตรวจคัดกรองมะเร็งปากมดลูก พบเชื้อรา ควรพบแพทย์', null);
INSERT INTO `tblcode` VALUES ('16', 'ผลการตรวจคัดกรองมะเร็งปากมดลูก พบเซลล์ผิดปกติ ควรตรวจซ้ำเมื่อครบ 3 เดือน หากมีอาการผิดปกติ เช่น มี\r\r\nเลือดออกทางช่องคลอด มีตกขาว สีหรือกลิ่นผิดปกติ ปวดท้องน้อยเป็นประจำ เลือดออกหลังมีเพศสัมพันธ์ ฯลฯ \r\r\nควรพบแพทย์เพื่อตรวจเพิ่มเติมทันที', null);
INSERT INTO `tblcode` VALUES ('17', 'ผลการตรวจคัดกรองมะเร็งปากมดลูก พบเซลล์มีการเสื่อมสภาพตามวัย ไม่เป็นปัญหาต่อสุขภาพ', null);
INSERT INTO `tblcode` VALUES ('18', 'พบโปรตีนในปัสสาวะ อาจเกิดจากไตทำงานผิดปกติควรตรวจปัสสาวะซ้ำ', null);
INSERT INTO `tblcode` VALUES ('19', 'พบน้ำตาลในปัสสาวะ อาจเกิดจากมีภาวะเบาหวานควรพบแพทย์', null);
INSERT INTO `tblcode` VALUES ('20', 'พบเม็ดเลือดแดงในปัสสาวะ อาจมีภาวะติดเชื้อในระบบทางเดินปัสสาวะ หรือมีนิ่ว ควรตรวจปัสสาวะซ้ำ', null);
INSERT INTO `tblcode` VALUES ('21', 'พบเม็ดเลือดขาวในปัสสาวะ อาจมีภาวะติดเชื้อในระบบทางเดินปัสสาวะ ควรดื่มน้ำมากๆ หลีกเลี่ยงการกลั้น\r\r\nปัสสาวะนานๆ หากมีอาการปัสสาวะแสบขัด หรือมีไข้ ควรพบแพทย์', null);
INSERT INTO `tblcode` VALUES ('22', 'พบคีโตนในปัสสาวะ อาจเกิดจากไตทำงานผิดปกติควรตรวจปัสสาวะซ้ำ', null);
INSERT INTO `tblcode` VALUES ('23', 'ผลการตรวจเม็ดเลือดแดงพบว่า มีภาวะซีด อาจเกิดได้จากหลายสาเหตุ เช่น ขาดธาตุเหล็ก โลหิตจาง ธาลัสซีเมีย \r\r\nเป็นต้น ควรพักผ่อนให้เพียงพอ รับประทานอาหารที่มีประโยชน์ เช่น ผักใบเขียว เครื่องในสัตว์ ฯลฯ', null);
INSERT INTO `tblcode` VALUES ('24', 'ผลการตรวจเลือดพบเม็ดเลือดแดงมีรูปร่างผิดปกติ อาจเกิดจากภาวะโลหิตจางบางชนิด ควรพักผ่อนให้เพียงพอ \r\r\nรับประทานอาหารที่มีประโยชน์ เช่น ผักใบเขียว เครื่องในสัตว์ ฯลฯ', null);
INSERT INTO `tblcode` VALUES ('25', 'ผลการตรวจเลือดพบ Eosinophil มากกว่า 6 อาจมีภาวะภูมิแพ้ หรืออาจมีพยาธิ', null);
INSERT INTO `tblcode` VALUES ('26', 'ผลการตรวจเลือดพบเม็ดเลือดขาวสูงกว่าปกติ อาจเกิดจากการติดเชื้อในร่างกาย หากมีไข้ หรืออาการผิดปกติอื่น\r\r\nร่วมด้วย ควรพบแพทย์เพื่อตรวจวินิจฉัยเพิ่ม', null);
INSERT INTO `tblcode` VALUES ('27', 'พบน้ำตาลในเลือดสูงเล็กน้อย มีแนวโน้มในการเกิดโรคเบาหวาน ควรควบคุมอาหารประเภทแป้งและน้ำตาล ผลไม้\r\r\nรสหวานจัด เช่น ทุเรียน ขนุน มะม่วงสุก ฯลฯ ออกกำลังกายอย่างสม่ำเสมอ ควรตรวจเลือดซ้ำอีก 3 เดือน และงด\r\r\nอาหาร 8-12 ชม. ก่อนเจาะเลือด', null);
INSERT INTO `tblcode` VALUES ('28', 'พบน้ำตาลในเลือดสูงปานกลาง อาจเป็นโรคเบาหวาน \nควรควบคุมอาหารประเภทแป้งและน้ำตาล ผลไม้รสหวานจัด \r\r\nเช่น ทุเรียน ขนุน มะม่วงสุก ฯลฯ ออกกำลังกายอย่างสม่ำเสมอ ควรตรวจเลือดซ้ำอีก 3 เดือน และงดอาหาร 8-12 \r\r\nชม. ก่อนเจาะเลือด', null);
INSERT INTO `tblcode` VALUES ('29', 'พบน้ำตาลในเลือดสูงมาก เป็นโรคเบาหวาน ควรพบแพทย์เพื่อรับการรักษาอย่างต่อเนื่อง และควรควบคุมอาหาร\r\r\nประเภทแป้งและน้ำตาล ผลไม้รสหวานจัด เช่น ทุเรียน ขนุน มะม่วงสุก ฯลฯ ออกกำลังกายอย่างสม่ำเสมอ ควร\r\r\nตรวจเลือดซ้ำอีก 3 เดือน และงดอาหาร 8-12 ชม. ก่อนเจาะเลือด', null);
INSERT INTO `tblcode` VALUES ('30', 'เป็นเบาหวาน ควรควบคุมระดับน้ำตาลในเลือดให้อยู่ในระดับปกติ และรับการรักษาอย่างต่อเนื่อง ควรควบคุม\r\r\nอาหารประเภทแป้งและน้ำตาล ผลไม้รสหวานจัด เช่น ทุเรียน ขนุน มะม่วงสุก ฯลฯ ออกกำลังกายอย่างสม่ำเสมอ \r\r\nเพื่อป้องกันภาวะแทรกซ้อน เช่น โรคไตวาย แผลเรื้อรัง ฯลฯ', null);
INSERT INTO `tblcode` VALUES ('31', 'มีภาวะความดันโลหิตสูงและเบาหวานร่วมด้วย ควรควบคุมระดับน้ำตาลในเลือดให้ใกล้เคียงระดับปกติ และรับการ\r\n\r\nรักษาอย่างต่อเนื่อง เพื่อป้องกันภาวะแทรกซ้อน เช่น ไตวาย โรคหัวใจ อัมพาต', null);
INSERT INTO `tblcode` VALUES ('32', 'ผลการตรวจเลือดพบการทำงานของไตมีค่าสูงกว่าปกติ หากมีอาการบวมบริเวณหน้า มือ ขา เท้า ควรพบแพทย์ \r\r\nควรหลีกเลี่ยงอาหารประเภทเค็มจัดที่มีเกลือเป็นส่วนประกอบ', null);
INSERT INTO `tblcode` VALUES ('33', 'ผลการตรวจเลือดพบเอนไซม์ตับสูงเล็กน้อย อาจเกิดจากการรับประทานยาบางชนิด หรือมีการอักเสบของข้อ รวม\r\r\nทั้งอาจเกิดจากการออกกำลังกายมากเกินไป', null);
INSERT INTO `tblcode` VALUES ('34', 'ผลการตรวจเลือดพบเอนไซม์ตับสูงมาก ควรพบแพทย์', null);
INSERT INTO `tblcode` VALUES ('35', 'พบกรดยูริคในเลือดสูง ควรหลีกเลี่ยงอาหารประเภทสัตว์ปีก  เครื่องในสัตว์ ถั่วฝัก  เห็ด  หากมีการอักเสบตามข้อ ควรพบแพทย์', null);
INSERT INTO `tblcode` VALUES ('99', '', null);
INSERT INTO `tblcode` VALUES ('37', 'พบไขมันในเลือดชนิดโคเลสเตอรอลสูงปานกลาง มีความเสี่ยงต่อการเกิดโรคหัวใจและหลอดเลือดควรพบแพทย์', null);
INSERT INTO `tblcode` VALUES ('38', 'พบไขมันในเลือดชนิดโคเลสเตอรอลสูงมาก มีโอกาสเกิดโรคหัวใจและหลอดเลือดได้ง่ายควรพบแพทย์', null);
INSERT INTO `tblcode` VALUES ('39', 'พบไขมันในเลือดชนิดไตรกลีเซอไรด์สูงเล็กน้อย ควรหลีกเลี่ยงอาหารประเภทไขมันสูง เครื่องดื่มแอลกอฮอล์ \r\r\nควรออกกำลังกายอย่างเหมาะสม และตรวจไขมันในเลือดทุก 3-6 เดือน', null);
INSERT INTO `tblcode` VALUES ('40', 'พบไขมันในเลือดชนิดไตรกลีเซอไรด์สูงปานกลาง มีความเสี่ยงต่อการเกิดโรคหัวใจและหลอดเลือดควรพบแพทย์', null);
INSERT INTO `tblcode` VALUES ('36', 'พบไขมันในเลือดชนิดโคเลสเตอรอลสูงเล็กน้อย ควรหลีกเลี่ยงอาหารประเภทไขมันสูง เช่น ปลาหมึก กุ้ง หอย ปู \r\r\nเครื่องในสัตว์ ไข่แดง เนื้อสัตว์ติดมัน ควรออกกำลังกายอย่างเหมาะสม และตรวจไขมันในเลือดทุก 3-6 เดือน', null);
INSERT INTO `tblcode` VALUES ('41', 'พบไขมันในเลือดชนิดไตรกลีเซอไรด์สูงมาก มีโอกาสเกิดโรคหัวใจและหลอดเลือดได้ง่าย', null);
INSERT INTO `tblcode` VALUES ('42', 'ไม่พบเชื้อไวรัสตับอักเสบบี และยังไม่มีภูมิคุ้มกันไวรัสตับอักเสบบี ควรรับการฉีดวัคซีน', null);
INSERT INTO `tblcode` VALUES ('43', 'พบเชื้อไวรัสตับอักเสบบี ควรงดเครื่องดื่มแอลกอฮอล์ งดสูบ\r\r\nบุหรี่ หลีกเลี่ยงอาหารที่มีไขมันสูง งดบริจาคเลือดและอวัยวะ ควรป้องกันเมื่อมีเพศสัมพันธฺ์ ควรตรวจเลือดซ้ำทุก 6 \r\r\nเดือน ถ้ามีอาการตาหรือตัวเหลือง อ่อนเพลีย เบื่ออาหาร ควรปรึกษาแพทย์', null);
INSERT INTO `tblcode` VALUES ('44', 'ตรวจพบมีภูมิคุ้มกันไวรัสตับอักเสบบี', null);
INSERT INTO `tblcode` VALUES ('51', 'ไขมันโคเลสเตอรอลและไตรกลีเซอไรด์สูงมาก ควรพบแพทย์', null);
INSERT INTO `tblcode` VALUES ('52', 'มีภาวะความดันโลหิตสูง  ควรรับการรักษาอย่างต่อเนื่องและควบคุมความดันโลหิตให้อยู่ในระดับใกล้เคียงปกติเพื่อป้องกันภาวะแทรกซ้อน เช่น ไตวาย  อัมพาต', null);
INSERT INTO `tblcode` VALUES ('53', 'การได้ยินลดลงในช่วงความถี่เสียงพูดคุยของหูข้างขวา', null);
INSERT INTO `tblcode` VALUES ('54', 'การได้ยินลดลงในช่วงความถี่เสียงพูดคุยของหูทั้งสองข้าง', null);
INSERT INTO `tblcode` VALUES ('55', 'การได้ยินลดลงเฉพาะในช่วงความถี่สูงของหูข้างซ้าย', null);
INSERT INTO `tblcode` VALUES ('56', 'การได้ยินลดลงเฉพาะในช่วงความถี่สูงของหูข้างขวา', null);
INSERT INTO `tblcode` VALUES ('57', 'การได้ยินลดลงเฉพาะในช่วงความถี่สูงของหูทั้งสองข้าง', null);
INSERT INTO `tblcode` VALUES ('58', 'การได้ยินลดลงเฉพาะในช่วงความถี่สูง แต่การได้ยินเสียงพูดคุยปกติ จึงไม่มีปัญหาการรับฟังเสียงพูดคุยในชีวิต\r\r\nประจำวัน ส่วนใหญ่เกิดจากการสัมผัสเสียงดังเป็นเวลานาน ดังนั้นจึงควรใช้อุปกรณ์ลดเสียงอย่างเคร่งครัด', null);
INSERT INTO `tblcode` VALUES ('59', 'การได้ยินลดลงในช่วงความถี่สูง รวมทั้งค่าเฉลี่ยการได้ยินในช่วงความถี่เสียงพูดคุยก็ลดลงด้วย อาจทำให้การรับ\r\r\nฟังเสียงพูดคุยผิดปกติไป จึงควรใช้อุปกรณ์ลดเสียงอย่างเคร่งครัด', null);
INSERT INTO `tblcode` VALUES ('60', 'การทดสอบสมรรถภาพปอด เพื่อตรวจสอบประเมินความจุอากาศของปอด และสภาพของหลอดลมอยู่ในเกณฑ์\r\r\nปกติ', null);
INSERT INTO `tblcode` VALUES ('61', '(Restrictive) ความจุปอดหรือปอดขยายตัวได้น้อยกว่าเกณฑ์ปกติ ควรออกกำลังกายประเภทที่ทำให้ปอดขยายตัว \r\r\nเช่น ว่ายน้ำ ฝึกลมหายใจเข้าออก', null);
INSERT INTO `tblcode` VALUES ('62', '(Obstructive) มีความผิดปกติแบบหลอดลมอุดกั้น มีอัตราการไหลของอากาศที่เป่าลดลง หากมีอาการเหนื่อย \r\r\nแน่นหน้าอก ควรพบแพทย์เพื่อรับการตรวจวินิจฉัยเพิ่มเติม', null);
INSERT INTO `tblcode` VALUES ('63', '(Combined) มีความผิดปกติแบบผสม ทั้งปอดขยายตัวได้น้อยกว่าเกณฑ์ปกติและมีหลอดลมอุดกั้น', null);
INSERT INTO `tblcode` VALUES ('64', 'การทดสอบสมรรถภาพการมองเห็น อยู่ในเกณฑ์ปกติ', null);
INSERT INTO `tblcode` VALUES ('65', 'ตรวจร่างกายพบเสียงหัวใจเต้นผิดปกติ  ควรพบแพทย์เฉพาะทางเพื่อตรวจวินิจฉัยโรค', null);
INSERT INTO `tblcode` VALUES ('66', 'การมองความชัดลึกของภาพผิดปกติ', null);
INSERT INTO `tblcode` VALUES ('67', 'การมองเห็นสีผิดปกติ', null);
INSERT INTO `tblcode` VALUES ('68', 'มีภาวะตาเขซ่อนเร้น', null);
INSERT INTO `tblcode` VALUES ('69', 'ลานสายตาผิดปกติ', null);
INSERT INTO `tblcode` VALUES ('70', 'การมองเห็นภาพสามมิติไม่ชัด การกะระยะและมองความชัดลึกของภาพต่ำกว่าเกณฑ์มาตรฐาน ควรหลีกเลี่ยง\r\r\nการทำงานที่เกี่ยวข้องกับเครื่องจักรที่เคลื่อนไหว เพราะอาจเกิดอุบัติเหตุได้ง่าย', null);
INSERT INTO `tblcode` VALUES ('71', 'ตาบอดสี ควรหลีกเลี่ยงการทำงานที่ต้องอ่านสัญลักษณ์สีต่างๆ เช่น ขับรถ เพราะอาจเกิดความผิดพลาดได้ง่าย', null);
INSERT INTO `tblcode` VALUES ('14', 'ผลการตรวจคัดกรองมะเร็งปากมดลูก พบปากมดลูกอักเสบ หากมีตกขาวสีเหลืองหรือสีเขียว มีกลิ่นเหม็น หรือคันช่องคลอดควรพบแพทย์', null);
INSERT INTO `tblcode` VALUES ('50', 'ไขมันโคเลสเตอรอลและไตรกลีเซอไรด์สูงเล็กน้อย  ควรหลีกเลี่ยงอาหารที่มีไขมันสูง ของหวาน  เครื่องดื่มที่มีแอลกอฮอล์  ออกกำลังกายอย่างเหมาะสมและตรวจไขมันในเลือดทุก 3- 6 เดือน', null);
INSERT INTO `tbldoctor` VALUES ('0', 'ยังไม่มีการระบุ', null, '1', '1', null);
INSERT INTO `tblnormal` VALUES ('ช', '13', '18', '(13-18g%)', '35', '60', '(35-60%)', '5000', '10000', '(5000-10000)', '4.5', '6.5', '(4.5-6.5)', '80', '100', '(80-100 fL)', '26', '34', '(26-34 pg)', '31', '37', '(31-37 g/dl)', '(0-15 %)', '15', '11', '(0-11 fL)', '40', '75', '(40-75%)', '(20-50%)', '50', '(20-50%)', '1', '6', '(1-6%)', '2', '6', '(2-6%)', '1', '(0-1%)', null, '140', '440', '(140-440 k/cu.mm.)', '70', '110', '(70-110 mg%)', '8', '23', '(8-23 mg/dl)', '0', '1.5', '(0-1.5 mg/dl)', '0', '8.5', '(0-8.5mg/dl)', '0', '200', '(0-200 mg/dl)', '0', '150', '(0-150 mg/dl)', '>35', '60', '(>35 mg%)', '130', '(0-130 mg%)', '38', '126', '(38-126U/ml)', '(0-46 U/L)', '46', '66', '(0-66 U/L)', 'Neg', 'Neg', '(97-169 ug/dl)', '(5.5-11.0 ug/dl)', '(0.46-4.68 m/U/ml)', '97', '169', '5.5', '11', '0.46', '4.68', 'Neg-Trace', 'Neg', '4.5', '8', '(4.5-8.0)', '1.003', '1.03', '(1.003-1.030)', 'Neg', 'Neg', 'Neg', 'Neg', 'Neg');
INSERT INTO `tblnormal` VALUES ('ญ', '12', '16', '(12-16g%)', '32', '60', '(32-60%)', '5000', '10000', '(5000-10000)', '4.2', '5.5', '(4.2-5.5)', '80', '100', '(80-100 fL)', '26', '34', '(26-34 pg)', '31', '37', '(31-37 g/dl)', '(0-15 %)', '15', '11', '(0-11 fL)', '40', '75', '(40-75%)', '(20-50%)', '50', '(20-50%)', '1', '6', '(1-6%)', '2', '6', '(2-6%)', '1', '(0-1%)', null, '140', '440', '(140-440 k/cu.mm.)', '50', '110', '(50-110 mg%)', '7', '17', '(7-17 mg/dl)', '0.5', '1.5', '(0.5-1.5 mg/dl)', '0', '7', '(0-7 mg/dl)', '0', '200', '(0-200 mg/dl)', '0', '150', '(0-150 mg/dl)', '>45', '70', '>45mg%)', '150', '(0-150 mg%)', '36', '126', '(36-126 U/ml)', '(0-31 U/L)', '31', '32', '(0-32 U/L)', 'Neg', 'Neg', '(97-169 ug/dl)', '(5.5-11.0 ug/dl)', '(0.46-4.68 m/U/ml)', '97', '169', '5.5', '11', '0.46', '4.68', 'Neg-Trace', 'Neg', '4.5', '8', '(4.5-8.0)', '1.003', '1.03', '(1.003-1.030)', 'Neg', 'Neg', 'Neg', 'Neg', 'Neg');
